import bge
import traceback
from functions import *
from operator import itemgetter
import pickle
# variables defined here will only be set once when the
# module is first imported. Set object specific vars
# inside the function if you intend to use the module
# with multiple objects.


logic = bge.logic
keyboard = logic.keyboard

def loadScores():
	try:
		
		pickle_in = open(logic.expandPath("//") + "scores.pickle", "rb")
		scores_loaded = pickle.load(pickle_in)
		print ("scores loaded")
		return scores_loaded
	except:
		print ("Loading failed")
		init_scores = []
		return init_scores
		

	
	

def onStart(cont):
	own = cont.owner
	sensors = own.sensors
	scene = logic.getCurrentScene()
	
	if sensors["OnStartScene"].positive:
		if scene.name == "00_Main":
			logic.hsm = own
			
			scores = loadScores()
			logic.hsm_scores = scores
			
			print (scores)
			

def saveScores(scores):
	pickle_out = open(logic.expandPath("//") + "scores.pickle", "wb")
	pickle.dump(scores, pickle_out)
	pickle_out.close()
	


def update(cont):
	own = cont.owner
	sensors = own.sensors
	scene = logic.getCurrentScene()
	
	if sensors["Update"].positive:
		if scene.name == "04_Death":
			JUST_ACTIVATED = logic.KX_INPUT_JUST_ACTIVATED
			if JUST_ACTIVATED in keyboard.inputs[bge.events.ENTERKEY].queue:
				#print ("score entered")
				print (logic.mgc["points"])
				obj_score_text = scene.objects['ScoreText']
				if 'Text' in obj_score_text:
					score_text = obj_score_text['Text'].replace("\n", "")
					#FIXME: only save score when string not empty
					new_score = [logic.mgc["points"], score_text]
					logic.hsm_scores.append(new_score)
					logic.hsm_scores = sorted(logic.hsm_scores, key = itemgetter(0), reverse = True)
					saveScores(logic.hsm_scores[:10])
					
				restart_dialog = scene.objectsInactive["Restart Dialog"] #FIXME: check if exists
				scene.addObject(restart_dialog)
				own.endObject()



def setScoreText(cont):
	own = cont.owner
	sensors = own.sensors
	scene = logic.getCurrentScene()
	
	if sensors["Score"].positive:
		print ("update scores now")
		own["Text"] = ""
		own.resolution = 4
		own.color = [0.9, 0.8, 0.4, 0.6]
		for score in logic.hsm_scores:
			print (score[0])
			if own.name == "Score Text 1":
				own["Text"] = own["Text"] + str(score[0]) + "\n"
			elif own.name == "Score Text 2":
				own["Text"] = own["Text"] + str(score[1]) + "\n"
			#	print ("update scores now - 1")