import bge
from functions import *

logic = bge.logic
mouse = logic.mouse
keyboard = logic.keyboard



def startClicked(cont):
	own = cont.owner
	sensors = own.sensors
	scene = logic.getCurrentScene()
	
	if scene.name == "02_Menu":
		JUST_ACTIVATED = logic.KX_INPUT_JUST_ACTIVATED
		
		if sensors["StartHovered"].positive:
			if JUST_ACTIVATED in mouse.inputs[bge.events.LEFTMOUSE].queue:            
				startGame()
		if sensors["StartHovered"].status ==  bge.logic.KX_SENSOR_JUST_ACTIVATED:
			showGUIElement(scene, "gold_start", True)
			showGUIElement(scene, "gold_scores", False)
			showGUIElement(scene, "gold_exit", False)
			logic.mc['activeButton'] = 0

def scoresClicked(cont):
	own = cont.owner
	sensors = own.sensors
	scene = logic.getCurrentScene()
	
	if scene.name == "02_Menu":
		JUST_ACTIVATED = logic.KX_INPUT_JUST_ACTIVATED
		
		if sensors["ScoresHovered"].positive:
			if JUST_ACTIVATED in mouse.inputs[bge.events.LEFTMOUSE].queue:  
				showGUIElements(scene, "GUI Highscore", True)
				showGUIElements(scene, "GUI Main", False)
				logic.sendMessage("showScore")
		if sensors["ScoresHovered"].status ==  bge.logic.KX_SENSOR_JUST_ACTIVATED:
			showGUIElement(scene, "gold_scores", True)
			showGUIElement(scene, "gold_start", False)
			showGUIElement(scene, "gold_exit", False)
			logic.mc['activeButton'] = 1
       
def exitClicked(cont):
	own = cont.owner
	sensors = own.sensors
	scene = logic.getCurrentScene()
	
	if scene.name == "02_Menu":
		JUST_ACTIVATED = logic.KX_INPUT_JUST_ACTIVATED
		
		if sensors["ExitHovered"].positive:
			if JUST_ACTIVATED in mouse.inputs[bge.events.LEFTMOUSE].queue:            
				logic.endGame()
		if sensors["ExitHovered"].status ==  bge.logic.KX_SENSOR_JUST_ACTIVATED:
			showGUIElement(scene, "gold_exit", True)
			showGUIElement(scene, "gold_scores", False)
			showGUIElement(scene, "gold_start", False)
			logic.mc['activeButton'] = 2
			

def showActiveButton(buttonID, scene):
	if buttonID == 0:
		showGUIElement(scene, "gold_start", True)
		showGUIElement(scene, "gold_exit", False)
		showGUIElement(scene, "gold_scores", False)
	elif buttonID == 1:
		showGUIElement(scene, "gold_exit", False)
		showGUIElement(scene, "gold_start", False)
		showGUIElement(scene, "gold_scores", True)
	elif buttonID == 2:
		showGUIElement(scene, "gold_exit", True)
		showGUIElement(scene, "gold_start", False)
		showGUIElement(scene, "gold_scores", False)
	else:
		print("error: button ID not found (showActiveButton)")
		
	

def handleMenuInput(cont):
	own = cont.owner
	sensors = own.sensors
	scene = logic.getCurrentScene()
	
	if scene.name == "02_Menu" and 'activeButton' in own:
		if sensors["Update"].positive:
			#buttons = own['buttons']
			maxIndex = 2
		
			JUST_ACTIVATED = logic.KX_INPUT_JUST_ACTIVATED
			if JUST_ACTIVATED in keyboard.inputs[bge.events.ENTERKEY].queue or JUST_ACTIVATED in keyboard.inputs[bge.events.SPACEKEY].queue:
				
				if own['activeButton'] == 0:
					startGame()
				elif own['activeButton'] == 2:
					logic.endGame()
				else:
					print("error: button ID not found")
					
			if JUST_ACTIVATED in keyboard.inputs[bge.events.DOWNARROWKEY].queue:
				
				if own['activeButton'] < maxIndex:
					own['activeButton'] = own['activeButton'] + 1
					showActiveButton(own['activeButton'], scene)
					
			if JUST_ACTIVATED in keyboard.inputs[bge.events.UPARROWKEY].queue:
				
				if own['activeButton'] > 0:
					own['activeButton'] = own['activeButton'] - 1
					showActiveButton(own['activeButton'], scene)


def restartClicked(cont):
	own = cont.owner
	sensors = own.sensors
	scene = logic.getCurrentScene()
	
	if scene.name == "04_Death":
		JUST_ACTIVATED = logic.KX_INPUT_JUST_ACTIVATED
		
		if sensors["RestartHovered"].positive:
			if JUST_ACTIVATED in mouse.inputs[bge.events.LEFTMOUSE].queue:            
				startGame()
				
def menuClicked(cont):
	own = cont.owner
	sensors = own.sensors
	scene = logic.getCurrentScene()
	
	if scene.name == "04_Death":
		JUST_ACTIVATED = logic.KX_INPUT_JUST_ACTIVATED
		
		if sensors["MenuHovered"].positive:
			if JUST_ACTIVATED in mouse.inputs[bge.events.LEFTMOUSE].queue:            
				print("to menu")
				mgc = logic.mgc
				mgc['in_game'] = False
				scene.restart()
				logic.addScene("02_Menu")
						
				scene.end()

#used to re-activate main menu (currently when highscores are showing)
def backToMainMenu(cont):
	
	own = cont.owner
	sensors = own.sensors
	scene = logic.getCurrentScene()
	
	if scene.name == "02_Menu":
		JUST_ACTIVATED = logic.KX_INPUT_JUST_ACTIVATED
		if sensors["MenuHovered"].positive:
			if JUST_ACTIVATED in mouse.inputs[bge.events.LEFTMOUSE].queue: 
			#if sensors["MenuHovered"].status ==  bge.logic.KX_SENSOR_JUST_ACTIVATED:
				showGUIElements(scene, "GUI Main", True)
				showGUIElements(scene, "GUI Highscore", False)
				showGUIElement(scene, "gold_scores", False)
				showGUIElement(scene, "gold_start", True)
				showGUIElement(scene, "gold_exit", False)
				logic.mc['activeButton'] = 0


			



	