import bge
from functions import *

# variables defined here will only be set once when the
# module is first imported. Set object specific vars
# inside the function if you intend to use the module
# with multiple objects.


logic = bge.logic
keyboard = logic.keyboard


def collectGold(cont):
	own = cont.owner
	sensors = own.sensors
	scene = logic.getCurrentScene()

	sens_coin = cont.sensors["Coin"]
	
	if sens_coin.positive:
		if scene.name == "03_Hud":
			points_collectable = 0
			
			if sens_coin.bodies[0] == "silver":
				points_collectable = logic.mgc['points_silver']
			elif sens_coin.bodies[0] == "gold":
				points_collectable = logic.mgc['points_gold']
				
			logic.mgc['points'] = logic.mgc['points'] + points_collectable
			print (logic.mgc['points'])
            
def killPlayer(cont):
	own = cont.owner
	scene = logic.getCurrentScene()
	kill = cont.sensors['Kill']
    
	if kill.positive and not logic.mgc['isDebug']:
		if scene.name == "01_Game":
			print ("kill player now!")
			logic.sendMessage("game_over")
			logic.addScene("04_Death", 0)
			scene.end()


	
def roll(cont):
	own = cont.owner
	scene = logic.getCurrentScene()
	collision = cont.sensors['Collision']
	sens_trigger = cont.sensors['Triggered']
	
	if scene.name == "01_Game":
		gc = logic.gc
		if not 'hasStarted' in gc:
			print ("error: gc['hasStarted'] is not defined")
			return
		if gc['hasStarted'] == True:
			
			if sens_trigger.positive:
				if gc['speed'] < ( gc['maxSpeed'] - 0.06 - 0.01):
					print ("triggered")
					gc['speed'] = gc['speed'] + 0.06
				elif gc['speed'] < ( gc['maxSpeed'] - 0.01):
					print ("maxSpeed!!!!")
					gc['speed'] = gc['maxSpeed']
    
			if collision.positive:
				speed = gc['speed']
				velocity = [0, speed, 0]
				own.setLinearVelocity(velocity, True)
			
			
			ACTIVE = logic.KX_INPUT_ACTIVE
			turnSpeed = gc['turnSpeed']
		
			if ACTIVE in keyboard.inputs[bge.events.LEFTARROWKEY].status or ACTIVE in keyboard.inputs[bge.events.AKEY].status:
				own.applyTorque([0, 0, turnSpeed], True)
			
			elif ACTIVE in keyboard.inputs[bge.events.RIGHTARROWKEY].status or ACTIVE in keyboard.inputs[bge.events.DKEY].status:
				own.applyTorque([0, 0, -turnSpeed], True)			

def rotatePlayerModel(cont):
	own = cont.owner
	scene = logic.getCurrentScene()
	
	if scene.name == "01_Game":
		gc = logic.gc
		speed = gc['speed']
		
		if not 'hasStarted' in gc:
			print ("error: gc['hasStarted'] is not defined")
			return
		
		if gc['hasStarted'] == True:
			own.applyRotation([-speed * 0.052, 0, 0], True)
		
		