import bpy


def main(context):
    active = context.active_object
    print ("active: " +  str(active))
    lodlevels = active.lod_levels
    for ob in context.selected_objects:
        if ob.name != context.active_object.name:
            print ("next object")
            
            bpy.context.scene.objects.active = ob
            bpy.ops.object.lod_clear_all()
            index = 0
            for ll in lodlevels:
                print ("old ll dist: " + str(ll.distance))

                if (index != 0):
                    bpy.ops.object.lod_add()
                    added_ll = ob.lod_levels[index]
                    
                    added_ll.object = ll.object
                    added_ll.distance = ll.distance
                index = index + 1     



class SimpleOperator(bpy.types.Operator):
    """Tooltip"""
    bl_idname = "object.simple_operator"
    bl_label = "Copy LOD Settings To Selected"

    @classmethod
    def poll(cls, context):
        return context.active_object is not None and bpy.context.mode == 'OBJECT'

    def execute(self, context):
        main(context)
        return {'FINISHED'}


def register():
    bpy.utils.register_class(SimpleOperator)


def unregister():
    bpy.utils.unregister_class(SimpleOperator)


if __name__ == "__main__":
    register()

    # test call
    if bpy.ops.object.simple_operator.poll():
        bpy.ops.object.simple_operator()
